Bug 11714 - Listening for network interface changes doesn't work
Listening for network interface changes doesn't work
Product: Samba 4.1 and newer
Classification: Unclassified
Component: Winbind
All All
: P5 normal
: ---
Assigned To: Karolin Seeger
Samba QA Contact
Depends on:
Blocks: 11719
  Show dependency treegraph
Reported: 2016-02-04 14:54 UTC by Ralph Böhme
Modified: 2016-02-17 08:27 UTC (History)
3 users (show)

See Also:

Patch for 4.2, 4.3 and 4.4 cherry-picked from master (3.56 KB, patch)
2016-02-15 12:31 UTC, Ralph Böhme
metze: review+
vl: review+
martins: review+

Note You need to log in before you can comment on or make changes to this bug.
Description Ralph Böhme 2016-02-04 14:54:51 UTC
winbindd is watching for network interface address changes by virtue of our addrchange_send/recv() API that uses netlink to query the kernel for this information.


[2016/02/04 11:43:31.723123, 10, pid=17692, effective(0, 0), real(0, 0)] ../source3/lib/addrchange.c:154(addrchange_done)
  tdgram_recvfrom_recv returned Operation not supported
[2016/02/04 11:43:31.723176, 10, pid=17692, effective(0, 0), real(0, 0), class=winbind] ../source3/winbindd/winbindd.c:1486(winbindd_addr_changed)
  addrchange_recv failed: NT_STATUS_NOT_SUPPORTED, stop listening

strace shows a failing ioctl(fd, FIONREAD, ...) returning EOPNOTSUPP. We use the ioctl to determine the amount of pending data so we can allocate an appropriate buffer.

Patch to follow.
Comment 1 Martin Schwenke 2016-02-08 03:13:52 UTC
When this patch is finalised, can it please be backported to Samba 4.4, 4.3 and 4.2?

I'm opening a CTDB bug to track removal of the "smbcontrol winbindd ip-dropped ..." commands from CTDB's scripts...
Comment 2 Ralph Böhme 2016-02-15 12:31:10 UTC
Created attachment 11839 [details]
Patch for 4.2, 4.3 and 4.4 cherry-picked from master
Comment 3 Karolin Seeger 2016-02-16 07:58:21 UTC
(In reply to Ralph Böhme from comment #2)
Pushed to autobuild-v4-[4|3|2]-test.
Comment 4 Karolin Seeger 2016-02-17 08:27:32 UTC
(In reply to Karolin Seeger from comment #3)
Pushed to all branches.
Closing out bug report.